unit uCompSparseMatReal;

// unidad para trabajar con Matrices Esparsas en formato comprimido


{ SE VA A UTILIZAR EL FORMATO CSR: COMPRESSED SPARSE ROW Y SU FORMA MODIFICADA
  MSR: MODIFIED SPARSE ROW QUE PERMITE ALMACENAR LA DIAGONAL EN FORMA SEPARADA }

{ CSR

  LOS INDICES DE FILA NO SE ALMACENAN EXPLICITAMENTE SINO QUE EN SU LUGAR SE ALMACENA
  EL LUGAR DONDE COMENZARIA CADA FILA.

  V(1..nz)       : almacena el valor no nulo

  J(1..nz)       : almacena el numero de la columna del elemento no nulo

  I(1..n+1)      : almacena el lugar donde comienza cada fila en los vectores anteriores
                   se agrega un ultimo valor para que indique donde termina la ultima fila.

Donde
     nz es el numero de elementos no nulos
     n es el numero de filas o columnas de la matriz original.                  }


{ MSR

  ES IGUAL AL FORMATO CSR SOLO QUE SE USA OTRO VECTOR SOLO PARA ALMACENAR LOS
  ELEMENTOS DE LA DIAGONAL
                                                                                }



interface

uses
  Classes, SysUtils, MatReal,Math,
	xMatDefs;


type
	TCoeficiente = class
		private
			findice : Integer;
			fvalor : NReal;
		public
			property indice : Integer read findice write findice;
			property valor : NReal read fvalor write fvalor;

			Constructor Create(indice : Integer ; valor : NReal);
			Constructor Create_Clone(x : TCoeficiente);  //Clona el coeficiente

	end;

        TCompSparseMat = class
               private
                       nf, nc: integer;

                       // vectores para almacenar las diagonales.
                       findicediag: TDAofNInt;
                       fvalordiag: TDAofNReal;

                       // vectores para almacenar los valores fuera de la diagonal.
                       findice_fila: TDAofNInt;
                       fdirec: TDAofNInt;
                       findice_col: TDAofNInt;
                       fvalor: TDAofNReal;
               	public
			property indicediag : TDAofNInt read findicediag write findicediag;
			property valordiag : TDAofNReal read fvalordiag write fvalordiag;

                        property indice_fila : TDAofNInt read findice_fila write findice_fila;
			property direc : TDAofNInt read fdirec write fdirec;
			property indice_col : TDAofNInt read findice_col write findice_col;
			property valor : TDAofNReal read fvalor write fvalor;

			constructor Create_Init(filas,columnas: integer);
			//Constructor Create_Clone(x : TCoeficiente);


        end;


        function MatReal_To_CompSparse(M:TMatR):TCompSparseMat;
        function CompSparse_to_MatReal(M:TCompSparseMat):TMatR;

implementation



{************************************
 FUNCIONES DE CONVERSION
 ------------------------------------}


function MatReal_To_CompSparse(M:TMatR):TCompSparseMat;
begin

end;
function CompSparse_to_MatReal(M:TCompSparseMat):TMatR;
begin

end;


{************************
//Metodos de TCoeficiente
-------------------------}

Constructor TCoeficiente.Create(indice : Integer ; valor : NReal);
begin
	inherited Create;
	findice := indice;
	fvalor := valor;
end;

Constructor TCoeficiente.Create_Clone(x : TCoeficiente);
begin
	inherited Create;
	indice := x.indice;
	valor := x.valor;
end;

{****************************
//Metodos de TCompSparseMat
-----------------------------}
 constructor TCompSparseMat.Create_Init(filas,columnas: integer);
 var
 	 k: integer;
 begin
 	inherited Create;
 	nf:= filas;
 	nc:= columnas;
 	setlength( findicediag, filas+1);
        setlength( fvalordiag, filas+1);
        setlength( findice_fila, filas+1);
        setlength( fdirec, filas*columnas+1);
        setlength( findice_col, filas*columnas+1);
        setlength( fvalor, filas*columnas+1);
 end;

end.

