unit uprueba_prueba;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,

  typinfo,

  ucosa, usalasdejuego, uglobs

  ;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation


Procedure SetOrdProp_(Instance : TObject;PropInfo : PPropInfo;Value : Int64);
type
  TSetInt64ProcIndex=procedure(index:longint;i:Int64) of object;
  TSetInt64Proc=procedure(i:Int64) of object;
  TSetIntegerProcIndex=procedure(index,i:longint) of object;
  TSetIntegerProc=procedure(i:longint) of object;
var
  DataSize: Integer;
  AMethod : TMethod;
begin
  if PropInfo^.PropType^.Kind in [tkInt64,tkQword
  { why do we have to handle classes here, see also below? (FK) }
{$ifdef cpu64}
    ,tkInterface
    ,tkInterfaceRaw
    ,tkDynArray
    ,tkClass
{$endif cpu64}
    ] then
    DataSize := 8
  else
    DataSize := 4;
  if not(PropInfo^.PropType^.Kind in [tkInt64,tkQword,tkClass]) then
    begin
      { cut off unnecessary stuff }
      case GetTypeData(PropInfo^.PropType)^.OrdType of
        otSWord,otUWord:
          begin
            Value:=Value and $ffff;
            DataSize := 2;
          end;
        otSByte,otUByte:
          begin
            Value:=Value and $ff;
            DataSize := 1;
          end;
       end;
    end;
  case (PropInfo^.PropProcs shr 2) and 3 of
    ptfield:
      case DataSize of
        1: PByte(Pointer(Instance)+PtrUInt(PropInfo^.SetProc))^:=Byte(Value);
        2: PWord(Pointer(Instance)+PtrUInt(PropInfo^.SetProc))^:=Word(Value);
        4: PLongint(Pointer(Instance)+PtrUInt(PropInfo^.SetProc))^:=Longint(Value);
        8: PInt64(Pointer(Instance)+PtrUInt(PropInfo^.SetProc))^:=Value;
      end;
    ptstatic,
    ptvirtual :
      begin
        if ((PropInfo^.PropProcs shr 2) and 3)=ptStatic then
          AMethod.Code:=PropInfo^.SetProc
        else
          AMethod.Code:=PPointer(Pointer(Instance.ClassType)+PtrUInt(PropInfo^.SetProc))^;
        AMethod.Data:=Instance;
        if datasize=8 then
          begin
            if ((PropInfo^.PropProcs shr 6) and 1)<>0 then
              TSetInt64ProcIndex(AMethod)(PropInfo^.Index,Value)
            else
              TSetInt64Proc(AMethod)(Value);
          end
        else
          begin
            if ((PropInfo^.PropProcs shr 6) and 1)<>0 then
              TSetIntegerProcIndex(AMethod)(PropInfo^.Index,Value)
            else
              TSetIntegerProc(AMethod)(Value);
          end;
      end;
  end;
end;

procedure SetInt64Prop_2(Instance: TObject; PropInfo: PPropInfo; const Value: Int64);
begin
  SetOrdProp_(Instance,PropInfo,Value);
end;

Procedure SetInt64Prop_1(Instance: TObject; const PropName: string; const Value: Int64);
begin
  SetInt64Prop_2(Instance,FindPropInfo(Instance,PropName),Value);
end;

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  ACosa: TCosa;
  a: Int64;
  ACosita: TCosa;
  b: Int64;
  PropList: PPropList;
  PropListCount: Integer;
  prop1info: TPropInfo;
  prop2info: TPropInfo;
  prop3info: TPropInfo;
  q: TTypeKind;

  DataColumn: TDataColumnOfCosa;
  PropInfo: PPropInfo;
  TypeKind: TTypeKind;

  DataRow:        TDataRowOfCosa;
  DataTable:      TDataTableOfCosa;
  DataColumnList: TDataColumnListOfCosa;
  ClassOwner:     TClaseDeCosa;
  sval:           String;
  pval:           pointer;
  i: Integer;
  capa: Integer;


  ainteger: integer;
  astring:  string;
  aboolean: boolean;
  afloat:   double;
  descripcion: String;
  estabilizarInicio: Boolean;

begin

  ucosa.AlInicio;
  usalasdejuego.AlInicio;
  uglobs.AlInicio;

  DataRow:=TDataRowOfCosa.Create(1001);
  DataRow.AddDataCell(TDataCellOfCosa.Create('1'));
  DataRow.AddDataCell(TDataCellOfCosa.Create('Sala'));
  DataRow.AddDataCell(TDataCellOfCosa.Create('Sala De Juego'));
  DataRow.AddDataCell(TDataCellOfCosa.Create('1'));

  DataTable:=TDataTableOfCosa.Create('dt_TSalaDeJuego', TSalaDeJuego);
  DataTable.AddDataRow(DataRow);


  DataColumnList:=DataTable.GetDataColumnList();
  ClassOwner:=DataColumnList.ClassOwner;
  ACosa:=ClassOwner.Create();

  PropListCount:=typinfo.GetPropList(ClassOwner, PropList);

  for i:=0 to DataColumnList.Count-1 do
  begin

    DataColumn:=DataColumnList.Items[i];

    sval:=DataRow.DataCellList[i].sval;

    PropInfo:=typinfo.FindPropInfo(ClassOwner, DataColumn.ColumnName);
    TypeKind:=PropInfo^.PropType^.Kind;

    case TypeKind of
      tkInteger:
      begin
        DataColumn.DataType.Eval(sval, @ainteger);
        typinfo.SetOrdProp(ACosa, PropInfo, integer(ainteger));
      end;
      tkAString:
      begin
        DataColumn.DataType.Eval(sval, @astring);
        typinfo.SetOrdProp(ACosa, PropInfo, integer(astring));
      end;
      tkBool:
      begin
        DataColumn.DataType.Eval(sval, @aboolean);
        typinfo.SetOrdProp(ACosa, PropInfo, integer(aboolean));
      end;
      tkFloat:
      begin
        DataColumn.DataType.Eval(sval, @afloat);
        typinfo.SetFloatProp(ACosa, PropInfo, afloat);
      end;
    end;
  end;

  capa:=TSalaDeJuego(ACosa).capa;
  descripcion:=TSalaDeJuego(ACosa).descripcion;
  estabilizarInicio:=TSalaDeJuego(ACosa).estabilizarInicio;

end;

end.

