unit uConversions;

interface

uses
  Classes, SysUtils, xmatdefs;

type

  { TDataConversion }

  { TDataConversionOfCosa }

  TDataConversionOfCosa=class

    nResult:string;
    nVariable1:string;
    nVariable2:string;
    Active:boolean;
    DataColumnOwner:TClass;

    constructor Create(); overload;
    constructor Create(xnResult:string; xnVariable1:string; xnVariable2:string=''); overload;

    procedure Convert(var vResult:string; vVariable1:string; vVariable2:string=''); virtual; abstract; overload;

    procedure Convert(var vResult:string; vVariable1:string; theOperator:string; vVariable2:string); overload;

    procedure Free;
  end;

  { TSumConversion }

  { TSumDataConversionOfCosa }

  TSumDataConversionOfCosa=class(TDataConversionOfCosa)
    procedure Convert(var vResult:string; vVariable1:string; vVariable2:string='');override;
  end;

  { TAssignDataConversionOfCosa }

  TAssignDataConversionOfCosa=class(TDataConversionOfCosa)
    procedure Convert(var vResult:string; vVariable1:string; vVariable2:string); override;
  end;

  { TListConversion }

  { TListDataConversionOfCosa }

  TListDataConversionOfCosa=class(TList)
  protected
    function GetItem(Index: Integer): TDataConversionOfCosa;
  public
    function Add(DataConversion: TDataConversionOfCosa):integer;
    function FindConverterByName(xVariableName:string; var Converter:TDataConversionOfCosa):Boolean ;
    property Items[Index: Integer]: TDataConversionOfCosa read GetItem;

    procedure Free;
  end;

implementation

uses
  ucosa;

{ TListConversion }

function TListDataConversionOfCosa.GetItem(Index: Integer): TDataConversionOfCosa;
begin
  Result:=TDataConversionOfCosa(inherited Items[Index]);
end;

function TListDataConversionOfCosa.Add(DataConversion: TDataConversionOfCosa): integer;
begin
  inherited Add(DataConversion);
end;

function TListDataConversionOfCosa.FindConverterByName(xVariableName: string;
  var Converter: TDataConversionOfCosa): Boolean;
var
  i:integer;
begin
  Result:=False;
  Converter:=nil;
  for i:=0 to self.Count-1 do
  begin
    if LowerCase(self.Items[i].nResult) = LowerCase(xVariableName) then
    begin
      Converter:=self.Items[i];
      Result:=True;
      Exit();
    end;
  end;
end;

procedure TListDataConversionOfCosa.Free;
var
  i: Integer;
begin
  for i:=0 to Count-1 do
    Items[i].Free;

  inherited Free;
end;

{ TDataConversion }

constructor TDataConversionOfCosa.Create();
begin
  self.Active:=false;
end;

constructor TDataConversionOfCosa.Create(xnResult: string; xnVariable1: string;
  xnVariable2: string);
begin
  inherited Create();
  self.nResult:=xnResult;
  self.nVariable1:=xnVariable1;
  self.nVariable2:=xnVariable2;
end;

procedure TDataConversionOfCosa.Convert(var vResult: string;
  vVariable1: string; theOperator: string; vVariable2: string);
begin
  vResult:=vVariable1+theOperator+vVariable2;
end;

procedure TDataConversionOfCosa.Free;
begin
  DataColumnOwner:=nil;
  inherited Free();
end;

{ TSumDataConversion }

procedure TSumDataConversionOfCosa.Convert(var vResult: string;
  vVariable1: string; vVariable2: string);
begin
  self.Convert(vResult, vVariable1, '+', vVariable2);
end;

{ TAssignDataConversionOfCosa }

procedure TAssignDataConversionOfCosa.Convert(var vResult: string;
  vVariable1: string; vVariable2: string);
begin
  self.Convert(vResult, vVariable1, '', '');
end;

end.

