unit uCustomHashList;

{$mode delphi}

interface

uses
  Classes, SysUtils, contnrs;

type

  TCustomHashList=class;

  { TCustomHashListItem }

  TCustomHashListItem=class
    Data: String;
    Collection: TCustomHashList;
    constructor Create(xData:string;xCollection:TCustomHashList);
  end;

  { TCustomHashList }

  TCustomHashList = class(TFPHashList)
  private
    _collection: TFPHashList;
  protected
    function GetData(AName: ShortString): String;
    function GetCollection(AName: ShortString): TCustomHashList;
    function GetCount(): Integer;
  public
    constructor Create();
    function Add(const AName:shortstring; xData: String; xCollection:TCustomHashList=nil): Integer;
    function Find(const AName:shortstring): TCustomHashListItem;
    function FindData(const AName:shortstring): String;
    function FindCollection(const AName:shortstring): TCustomHashList;
    property Data[AName: ShortString]: String read GetData;
    property Collection[AName: ShortString]: TCustomHashList read GetCollection;
    function NameOfIndex(Index: Integer): ShortString;
    property Count: Integer read GetCount;
  end;

implementation

{ TCustomHashListItem }

constructor TCustomHashListItem.Create(xData: string;
  xCollection: TCustomHashList);
begin
  self.Data:=xData;
  self.Collection:=xCollection;
end;



{ TCustomHashList }

function TCustomHashList.GetData(AName: ShortString): String;
begin
  Result:=self.Find(LowerCase(AName)).Data;
end;

function TCustomHashList.GetCollection(AName: ShortString): TCustomHashList;
begin
  Result:=self.Find(LowerCase(AName)).Collection;
end;

function TCustomHashList.GetCount: Integer;
begin

end;

constructor TCustomHashList.Create;
begin
  self._collection:=TFPHashList.Create();
end;

function TCustomHashList.Add(const AName: shortstring; xData: String;
  xCollection: TCustomHashList): Integer;
var
  p:pointer;
  item:TCustomHashListItem;
begin
  New(p);
  TCustomHashListItem(p^):=TCustomHashListItem.Create(xData,xCollection);
  Result:=self._collection.Add(LowerCase(AName), p);
end;

function TCustomHashList.Find(const AName: shortstring): TCustomHashListItem;
begin
  Result:=TCustomHashListItem(self._collection.Find(LowerCase(AName))^);
end;

function TCustomHashList.FindData(const AName: shortstring): String;
var
  item:TCustomHashListItem;
begin
  item:=TCustomHashListItem(self._collection.Find(LowerCase(AName))^);
  Result:=item.Data;
end;

function TCustomHashList.FindCollection(const AName: shortstring
  ): TCustomHashList;
var
  item:TCustomHashListItem;
begin
  item:=TCustomHashListItem(self._collection.Find(LowerCase(AName))^);
  Result:=item.Collection;
end;

function TCustomHashList.NameOfIndex(Index: Integer): ShortString;
begin
  Result:=self._collection.NameOfIndex(Index);
end;

end.

